﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace GenericsUsing
{
    class Program
    {
        static void UsingGenericList()
        {
            List<String> list = new List<string>();
            list.Add("Anders");
            list.Add("Hello");
            //list.Add(34); // rejected by the compiler
            String s = list[0];
            foreach (String str in list)
            {
                Console.WriteLine(str);
            }

            List<int?> ll = new List<int?>();
            ll.Add(null);
            list.Add(null);

        }

        static void UsingNongenericList()
        {
            ArrayList list = new ArrayList();
            list.Add("Anders");
            list.Add("Hello");
            list.Add(34); // anything can be added to the list!
            Object obj = list[0];
            String s = (String) obj; 
            foreach (Object str in list)
            {
                Console.WriteLine(str);
            }
        }

        private static void UseHomemadeGenericList()
        {
            GenericList<int> list = new GenericList<int>();
            list.AddHead(4);
            list.AddHead(333);
            foreach (int number in list)
            {
                Console.WriteLine(number);
            }
        }

        static void Main(string[] args)
        {
            //UsingNongenericList();
            UseHomemadeGenericList();
        }
    }
}
